#!/usr/local/bin/jperl5

# top.pl
#	by T.Mori <mori@forest.eis.ynu.ac.jp>
#       Last modified: "2003/09/04 19:13:54 (JST)"
#
#   bunkenhtml-xref.bst  Ĥä줿 HTML ե뤫
#   _SECTION(󥿥ȥ)Фܼ롥
#
#   _SECTION(Ignore) ʹߤ̵뤹롥
#

#

if (defined($ARGV[0]) && $ARGV[0] eq 'en') {
  $eng = 1;
} else {
  $eng = 0;
}

main(\*STDIN, \*STDOUT);

sub main($$) {
  my($fh_in) = shift;
  my($fh_out) = shift;

  my($sec_no) = 0;

  print $fh_out "<hr>\n";
  print $fh_out "<a name=\"_TOC\">\n";
  if ($eng) {
    print $fh_out "<h2>Contents</h2>\n";
  } else {
    print $fh_out "<h2>ܼ</h2>\n";
  }
  print $fh_out "<p>\n";

  while (my $l = <$fh_in>) {
    chomp $l;

    if ($l =~ /\_SECTION\(Ignore\)/i) {
      last;
    } elsif ($l =~ /\_SECTION\(([^\)]*)\)/i) {
      print $fh_out "&nbsp;&nbsp;&nbsp;<a href=\"#_SECTION_$sec_no\">[$1]</a>\n";
      $sec_no++;
    }
  }

  my $curr_time = localtime;
  print $fh_out "</p>\n";
  print $fh_out "<p><ul>\n";
  if ($eng) {
    print $fh_out " <li>Papers are in reverse order of publication.</li>\n";
    print $fh_out " <li>Last modified: $curr_time </li>\n";
  } else {
    print $fh_out " <li>ȯɽΤɽƤޤ</li>\n";
    print $fh_out " <li>ǽ: $curr_time </li>\n";
  }
  print $fh_out "</ul></p>\n";

  print $fh_out "<hr>\n";
}
