#!/usr/local/bin/jperl5

# wrapup.pl
#	by T.Mori <mori@forest.eis.ynu.ac.jp>
#       Last modified: "2003/09/04 19:15:27 (JST)"
#
#   bunkenhtml-xref.bst  Ĥä줿 HTML եθ롥
#
#   1. BibTeXŪʬ䤷Ԥ򸵤᤹
#      (ʸ % С꼡ιԤȷ)
#   2.  _SECTION(󥿥ȥ) HTMLѴ롥
#      Ѵ륿ѿ $SECTAG ƤʲǤ h2 
#      <$SECTAG>󥿥ȥ</$SECTAG>
#      Ȥʤ롥
#   3. _SECTION(Ignore) ʹߤ̵뤹롥
#

# _SECTIONбHTML
$SECTAG = 'h2';
# SECTIONΥ
$sec_no = 0;
#

if (defined($ARGV[0]) && $ARGV[0] eq 'en') {
  $TOC_label = "TOC";
} else {
  $TOC_label = "ܼ";
}

main(\*STDIN, \*STDOUT);

sub main($$) {
  my($fh_in) = shift;
  my($fh_out) = shift;

  my $buf = '';
  while (my $l = <$fh_in>) {
    chomp $l;

    if ($l =~ s/%$//) { #% bibtexŪ˲Ԥޡ
      $buf .= $l;
    } else {
      if ($l =~ /\_SECTION\(Ignore\)/i) {
	if ($buf ne '') {
	  print $fh_out $buf,"\n";
	}
	last;
      }
      print $fh_out &filter($buf.$l),"\n";
      $buf = '';
    }
  }
}

sub filter($) {
  my($str) = shift;

  if ($str =~ /_SECTION\(([^\)]*)\)/i) {
    $str =~ s/_SECTION\(([^\)]*)\)/<a name=\"_SECTION_$sec_no\" \/>\n<$SECTAG>$1<\/$SECTAG>\n<a href=\"#_TOC\">[$TOC_label]<\/a>/og;
    $sec_no++;
  }

  return $str;
}
